/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.WithdrawLimit = factory(root.UpbitOpenApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The WithdrawLimit model module.
   * @module model/WithdrawLimit
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>WithdrawLimit</code>.
   * 출금 제약 정보
   * @alias module:model/WithdrawLimit
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>WithdrawLimit</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/WithdrawLimit} obj Optional instance to populate.
   * @return {module:model/WithdrawLimit} The populated <code>WithdrawLimit</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('currency'))
        obj.currency = ApiClient.convertToType(data['currency'], 'String');
      if (data.hasOwnProperty('minimum'))
        obj.minimum = ApiClient.convertToType(data['minimum'], 'String');
      if (data.hasOwnProperty('onetime'))
        obj.onetime = ApiClient.convertToType(data['onetime'], 'String');
      if (data.hasOwnProperty('daily'))
        obj.daily = ApiClient.convertToType(data['daily'], 'String');
      if (data.hasOwnProperty('remaining_daily'))
        obj.remainingDaily = ApiClient.convertToType(data['remaining_daily'], 'String');
      if (data.hasOwnProperty('remaining_daily_krw'))
        obj.remainingDailyKrw = ApiClient.convertToType(data['remaining_daily_krw'], 'String');
      if (data.hasOwnProperty('fixed'))
        obj.fixed = ApiClient.convertToType(data['fixed'], 'Number');
      if (data.hasOwnProperty('can_withdraw'))
        obj.canWithdraw = ApiClient.convertToType(data['can_withdraw'], 'Boolean');
    }
    return obj;
  }

  /**
   * 화폐를 의미하는 영문 대문자 코드
   * @member {String} currency
   */
  exports.prototype.currency = undefined;

  /**
   * 출금 최소 금액/수량
   * @member {String} minimum
   */
  exports.prototype.minimum = undefined;

  /**
   * 1회 출금 한도
   * @member {String} onetime
   */
  exports.prototype.onetime = undefined;

  /**
   * 1일 출금 한도
   * @member {String} daily
   */
  exports.prototype.daily = undefined;

  /**
   * 1일 잔여 출금 한도
   * @member {String} remainingDaily
   */
  exports.prototype.remainingDaily = undefined;

  /**
   * 통합 1일 잔여 출금 한도
   * @member {String} remainingDailyKrw
   */
  exports.prototype.remainingDailyKrw = undefined;

  /**
   * 출금 금액/수량 소수점 자리 수
   * @member {Number} fixed
   */
  exports.prototype.fixed = undefined;

  /**
   * 출금 지원 여부
   * @member {Boolean} canWithdraw
   */
  exports.prototype.canWithdraw = undefined;


  return exports;

}));
