# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' CandleMinutes Class
#'
#' @field market 
#' @field candle_date_time_utc 
#' @field candle_date_time_kst 
#' @field opening_price 
#' @field high_price 
#' @field low_price 
#' @field trade_price 
#' @field timestamp 
#' @field candle_acc_trade_price 
#' @field candle_acc_trade_volume 
#' @field unit 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
CandleMinutes <- R6::R6Class(
  'CandleMinutes',
  public = list(
    `market` = NULL,
    `candle_date_time_utc` = NULL,
    `candle_date_time_kst` = NULL,
    `opening_price` = NULL,
    `high_price` = NULL,
    `low_price` = NULL,
    `trade_price` = NULL,
    `timestamp` = NULL,
    `candle_acc_trade_price` = NULL,
    `candle_acc_trade_volume` = NULL,
    `unit` = NULL,
    initialize = function(`market`, `candle_date_time_utc`, `candle_date_time_kst`, `opening_price`, `high_price`, `low_price`, `trade_price`, `timestamp`, `candle_acc_trade_price`, `candle_acc_trade_volume`, `unit`){
      if (!missing(`market`)) {
        stopifnot(is.character(`market`), length(`market`) == 1)
        self$`market` <- `market`
      }
      if (!missing(`candle_date_time_utc`)) {
        stopifnot(is.character(`candle_date_time_utc`), length(`candle_date_time_utc`) == 1)
        self$`candle_date_time_utc` <- `candle_date_time_utc`
      }
      if (!missing(`candle_date_time_kst`)) {
        stopifnot(is.character(`candle_date_time_kst`), length(`candle_date_time_kst`) == 1)
        self$`candle_date_time_kst` <- `candle_date_time_kst`
      }
      if (!missing(`opening_price`)) {
        stopifnot(is.numeric(`opening_price`), length(`opening_price`) == 1)
        self$`opening_price` <- `opening_price`
      }
      if (!missing(`high_price`)) {
        stopifnot(is.numeric(`high_price`), length(`high_price`) == 1)
        self$`high_price` <- `high_price`
      }
      if (!missing(`low_price`)) {
        stopifnot(is.numeric(`low_price`), length(`low_price`) == 1)
        self$`low_price` <- `low_price`
      }
      if (!missing(`trade_price`)) {
        stopifnot(is.numeric(`trade_price`), length(`trade_price`) == 1)
        self$`trade_price` <- `trade_price`
      }
      if (!missing(`timestamp`)) {
        self$`timestamp` <- `timestamp`
      }
      if (!missing(`candle_acc_trade_price`)) {
        stopifnot(is.numeric(`candle_acc_trade_price`), length(`candle_acc_trade_price`) == 1)
        self$`candle_acc_trade_price` <- `candle_acc_trade_price`
      }
      if (!missing(`candle_acc_trade_volume`)) {
        stopifnot(is.numeric(`candle_acc_trade_volume`), length(`candle_acc_trade_volume`) == 1)
        self$`candle_acc_trade_volume` <- `candle_acc_trade_volume`
      }
      if (!missing(`unit`)) {
        self$`unit` <- `unit`
      }
    },
    toJSON = function() {
      CandleMinutesObject <- list()
      if (!is.null(self$`market`)) {
        CandleMinutesObject[['market']] <- self$`market`
      }
      if (!is.null(self$`candle_date_time_utc`)) {
        CandleMinutesObject[['candle_date_time_utc']] <- self$`candle_date_time_utc`
      }
      if (!is.null(self$`candle_date_time_kst`)) {
        CandleMinutesObject[['candle_date_time_kst']] <- self$`candle_date_time_kst`
      }
      if (!is.null(self$`opening_price`)) {
        CandleMinutesObject[['opening_price']] <- self$`opening_price`
      }
      if (!is.null(self$`high_price`)) {
        CandleMinutesObject[['high_price']] <- self$`high_price`
      }
      if (!is.null(self$`low_price`)) {
        CandleMinutesObject[['low_price']] <- self$`low_price`
      }
      if (!is.null(self$`trade_price`)) {
        CandleMinutesObject[['trade_price']] <- self$`trade_price`
      }
      if (!is.null(self$`timestamp`)) {
        CandleMinutesObject[['timestamp']] <- self$`timestamp`
      }
      if (!is.null(self$`candle_acc_trade_price`)) {
        CandleMinutesObject[['candle_acc_trade_price']] <- self$`candle_acc_trade_price`
      }
      if (!is.null(self$`candle_acc_trade_volume`)) {
        CandleMinutesObject[['candle_acc_trade_volume']] <- self$`candle_acc_trade_volume`
      }
      if (!is.null(self$`unit`)) {
        CandleMinutesObject[['unit']] <- self$`unit`
      }

      CandleMinutesObject
    },
    fromJSON = function(CandleMinutesJson) {
      CandleMinutesObject <- jsonlite::fromJSON(CandleMinutesJson)
      if (!is.null(CandleMinutesObject$`market`)) {
        self$`market` <- CandleMinutesObject$`market`
      }
      if (!is.null(CandleMinutesObject$`candle_date_time_utc`)) {
        self$`candle_date_time_utc` <- CandleMinutesObject$`candle_date_time_utc`
      }
      if (!is.null(CandleMinutesObject$`candle_date_time_kst`)) {
        self$`candle_date_time_kst` <- CandleMinutesObject$`candle_date_time_kst`
      }
      if (!is.null(CandleMinutesObject$`opening_price`)) {
        self$`opening_price` <- CandleMinutesObject$`opening_price`
      }
      if (!is.null(CandleMinutesObject$`high_price`)) {
        self$`high_price` <- CandleMinutesObject$`high_price`
      }
      if (!is.null(CandleMinutesObject$`low_price`)) {
        self$`low_price` <- CandleMinutesObject$`low_price`
      }
      if (!is.null(CandleMinutesObject$`trade_price`)) {
        self$`trade_price` <- CandleMinutesObject$`trade_price`
      }
      if (!is.null(CandleMinutesObject$`timestamp`)) {
        self$`timestamp` <- CandleMinutesObject$`timestamp`
      }
      if (!is.null(CandleMinutesObject$`candle_acc_trade_price`)) {
        self$`candle_acc_trade_price` <- CandleMinutesObject$`candle_acc_trade_price`
      }
      if (!is.null(CandleMinutesObject$`candle_acc_trade_volume`)) {
        self$`candle_acc_trade_volume` <- CandleMinutesObject$`candle_acc_trade_volume`
      }
      if (!is.null(CandleMinutesObject$`unit`)) {
        self$`unit` <- CandleMinutesObject$`unit`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "market": %s,
           "candle_date_time_utc": %s,
           "candle_date_time_kst": %s,
           "opening_price": %d,
           "high_price": %d,
           "low_price": %d,
           "trade_price": %d,
           "timestamp": %s,
           "candle_acc_trade_price": %d,
           "candle_acc_trade_volume": %d,
           "unit": %s
        }',
        self$`market`,
        self$`candle_date_time_utc`,
        self$`candle_date_time_kst`,
        self$`opening_price`,
        self$`high_price`,
        self$`low_price`,
        self$`trade_price`,
        self$`timestamp`,
        self$`candle_acc_trade_price`,
        self$`candle_acc_trade_volume`,
        self$`unit`
      )
    },
    fromJSONString = function(CandleMinutesJson) {
      CandleMinutesObject <- jsonlite::fromJSON(CandleMinutesJson)
      self$`market` <- CandleMinutesObject$`market`
      self$`candle_date_time_utc` <- CandleMinutesObject$`candle_date_time_utc`
      self$`candle_date_time_kst` <- CandleMinutesObject$`candle_date_time_kst`
      self$`opening_price` <- CandleMinutesObject$`opening_price`
      self$`high_price` <- CandleMinutesObject$`high_price`
      self$`low_price` <- CandleMinutesObject$`low_price`
      self$`trade_price` <- CandleMinutesObject$`trade_price`
      self$`timestamp` <- CandleMinutesObject$`timestamp`
      self$`candle_acc_trade_price` <- CandleMinutesObject$`candle_acc_trade_price`
      self$`candle_acc_trade_volume` <- CandleMinutesObject$`candle_acc_trade_volume`
      self$`unit` <- CandleMinutesObject$`unit`
    }
  )
)
